package com.steerinfo.dil.mapper;

import org.apache.ibatis.annotations.Mapper;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 规则方法
 * @ author    :TXF
 * @ time      :2021/11/16 14:28
 */

@Mapper
public interface RulesMapper {
    //根据物资Id、门岗规则 查询门岗id (可能会查询出多个)
    List<Map<String, Object>> queryGatepostByMaterialId(Map<String, Object> map);

    //通过物资Id、计量类型（进厂、出厂、中转） 可能会有多个称
    List<Integer> queryTruckCalculate(Map<String, Object> map);

    //查询未装车实绩
    List<Map<String, Object>> judgeLastMaterial(BigDecimal orderId);

    //通过门岗ID 和 网格类型 匹配 网格主键
    BigDecimal getGridIdByGatepostIdAndGridType(Map<String, Object> map);


    //通过物资Id查询仓库是否有货 或者 是否有多个仓库有货
    List<Integer> getWarehouseIdByMaterialId(Integer materialId);

    //通过仓库Id 和 物资Id 查询垛位 层次 月台 仓库
    List<Map<String, Object>> getStackGradation(Map<String, Object> map);

    //通过月台Id 查询月台当前排队车辆数
    BigDecimal queueCountByPlatformId(BigDecimal platformId);
}
