package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckMeasureCommission;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckMeasureCommissionMapper extends IBaseMapper<TmstruckMeasureCommission, BigDecimal> {

    //查询计量委托
    List<Map<String, Object>> getMeasureCommission(Map<String, Object> map);

    //查询最大主键Id
    @Select("select seq_measure_commission.nextval from dual")
    BigDecimal selectMaxId();

    //查询采购计量委托
    Map<String, Object> getCGMeasureCommission(Map<String, Object> map);

    //查询销售计量委托
    Map<String, Object> getXSMeasureCommission(Map<String, Object> map);

    /*
     * from zhangXuan
     */

    //通过订单ID查询收货单位ID
    Integer getReceiveIdByOrderId(BigDecimal orderId);

    //通过订单ID查询发货单位ID
    Integer getShipperIdByOrderId(BigDecimal orderId);

    //销售查询计毛
    Map<String, Object> selectMakesureGrossForSaleByOrderNumber(Map<String, Object> map);

    //销售查询计皮
    Map<String, Object> selectMakesureTareForSaleByOrderNumber(Map<String, Object> map);

    //内转查询计皮
    Map<String, Object> selectMakesureTareForConvertedByOrderNumber(Map<String, Object> map);

    //内转查询计毛
    Map<String, Object> selectMakesureGrossForConvertedByOrderNumber(Map<String, Object> map);

    //采购查询计皮
    Map<String, Object> selectMakesureGrossForPurchase(Map<String, Object> map);

    //采购查询计毛
    Map<String, Object> selectMakesureTareForPurchase(Map<String, Object> map);

    //采购计量委托
    Map<String, Object> purchaseMeasure(Map<String, Object> map);

    //采购计量委托（达兴）
    Map<String, Object> purchaseDXMeasure(Map<String, Object> map);

    //销售计量委托
    Map<String, Object> saleMeasure(Map<String, Object> map);

    //销售计量委托（达兴）
    Map<String, Object> saleDXMeasure(Map<String, Object> map);

    //零星物资进厂计量委托
    Map<String, Object> sporadicDXMeasure(Map<String, Object> map);

    Integer getReceiveIdByRequirementOrderId(Object orderId);

    Map<String, Object> purchaseXqCgNzDXMeasure(Map<String, Object> map);

}