package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckQualityResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckQualityResultMapper extends IBaseMapper<TmstruckQualityResult, BigDecimal> {

    //查询所有的质检作业
    List<Map<String, Object>> getQualityResult(Map<String, Object> map);

    //通过ID查询质检作业
    List<Map<String, Object>> getQualityResultById(Integer resultId);

    //获取主键
    @Select("select seq_tmstruck_quality.nextval from dual")
    BigDecimal selectMaxId();

    //内转物流查询质检作业
    List<Map<String,Object>>  selectQualityResultForConverted(Map<String,Object> map);

    //内转查询质检作业
    List<Map<String, Object>> getInwardQualityResult(Map<String, Object> map);
}