package com.steerinfo.dil.mapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/26 14:27
 */

@Mapper
public interface UtilsMapper {

    //查询运输订单最大主键Id
    @Select("select seq_omstruck_order.nextval from dual")
    BigDecimal selectOrderMaxId();

    //查询运输订单子表主键ID
    @Select("select seq_omstruck_order_material.nextval from dual")
    BigDecimal selectOrderMaterialMaxId();

    //通过订单Id修改订单状态
    int updateOrderStatusByOrderIdOrNum(Map<String, Object> map);

    //通过运输Id 或者运输订单号修改 路段顺序号
    int updateLineSeqByOrderIdOrNum(Map<String, Object> map);

    //通过运力ID 或车牌号 修改运力状态
    int updateCapacityByCarIdOrNum(Map<String, Object> map);

    //通过仓库名称查询仓库Id
    Integer queryWarehouseIdByName(String warehouseName);

    //通过月台名称查找月台Id platformName
    Integer queryPlatformIdByName(String platformName);

    //根据运输订单号查询物资Id
    BigDecimal queryOrderMesByOrderId(String orderNumber);

    //查询当前路段顺序号
    Integer getLineSequenceByOrderId(@Param("orderId") BigDecimal orderId);

    //查询订单跟订单物资中间表 查询是否有多个物资Id
    List<Integer> getAllMaterialId(Map<String, Object> map);

    //通过总实绩Id查询订单Id
    Integer getOrderIdByTotalId(Integer resultTotalId);

    //通过运输订单号查询订单ID
    BigDecimal getOrderIdByOrderNumber(String orderNumber);

    //通过运输订单号查询总实绩ID
    BigDecimal getTotalIdByOrderNumber(String orderNumber);

    //通过总实绩ID查找订单类型
    Integer getOrderTypeByTotalId(BigDecimal resultTotalId);

    //查询最大路段顺序号 以及当前订单路段顺序号（执行到哪一步）
    Map<String, Object> getLineSeqAndOrderSeq(Map<String, Object> map);

    //通过订单ID查询物资ID（针对单拼）
    List<Integer> getMaterialIdByOrderId(BigDecimal orderId);
}
