package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="卸货实绩")
public class TmstruckUnloadResult implements IBasePO<BigDecimal> {
    /**
     * 主键id(RESULT_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="主键id",required=true)
    private BigDecimal resultId;

    /**
     * 卸货实绩编号 DW+YYYYMMDD+5位流水(RESULT_NUMBER,VARCHAR,32)
     */
    @ApiModelProperty(value="卸货实绩编号 DW+YYYYMMDD+5位流水",required=false)
    private String resultNumber;

    /**
     * 实绩总表ID(RESULT_TOTAL_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="实绩总表ID",required=false)
    private BigDecimal resultTotalId;

    /**
     * 卸货开始时间(RESULT_START_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="卸货开始时间",required=false)
    private Date resultStartTime;

    /**
     * 卸货结束时间(RESULT_END_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="卸货结束时间",required=false)
    private Date resultEndTime;

    /**
     * 卸货时长(RESULT_DURATION,DECIMAL,0)
     */
    @ApiModelProperty(value="卸货时长",required=false)
    private BigDecimal resultDuration;

    /**
     * 卸货状态：拒绝；同意(UNLOAD_STATUS,VARCHAR,5)
     */
    @ApiModelProperty(value="卸货状态：拒绝；同意",required=false)
    private String unloadStatus;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 废除人(DELETE_NAME,VARCHAR,16)
     */
    @ApiModelProperty(value="废除人",required=false)
    private String deleteName;

    /**
     * 废除时间(DELETE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="废除时间",required=false)
    private Date deleteTime;

    /**
     * 卸货点(连原料仓库)(RESULT_UNLOAD_PLACE_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="卸货点(连原料仓库)",required=false)
    private BigDecimal resultUnloadPlaceId;

    /**
     * 路段顺序号(SEGMENT_SQE,DECIMAL,0)
     */
    @ApiModelProperty(value="路段顺序号",required=false)
    private BigDecimal segmentSqe;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.resultId;
    }

    @Override
    public void setId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getResultId() {
        return resultId;
    }

    public void setResultId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public String getResultNumber() {
        return resultNumber;
    }

    public void setResultNumber(String resultNumber) {
        this.resultNumber = resultNumber == null ? null : resultNumber.trim();
    }

    public BigDecimal getResultTotalId() {
        return resultTotalId;
    }

    public void setResultTotalId(BigDecimal resultTotalId) {
        this.resultTotalId = resultTotalId;
    }

    public Date getResultStartTime() {
        return resultStartTime;
    }

    public void setResultStartTime(Date resultStartTime) {
        this.resultStartTime = resultStartTime;
    }

    public Date getResultEndTime() {
        return resultEndTime;
    }

    public void setResultEndTime(Date resultEndTime) {
        this.resultEndTime = resultEndTime;
    }

    public BigDecimal getResultDuration() {
        return resultDuration;
    }

    public void setResultDuration(BigDecimal resultDuration) {
        this.resultDuration = resultDuration;
    }

    public String getUnloadStatus() {
        return unloadStatus;
    }

    public void setUnloadStatus(String unloadStatus) {
        this.unloadStatus = unloadStatus == null ? null : unloadStatus.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public String getDeleteName() {
        return deleteName;
    }

    public void setDeleteName(String deleteName) {
        this.deleteName = deleteName == null ? null : deleteName.trim();
    }

    public Date getDeleteTime() {
        return deleteTime;
    }

    public void setDeleteTime(Date deleteTime) {
        this.deleteTime = deleteTime;
    }

    public BigDecimal getResultUnloadPlaceId() {
        return resultUnloadPlaceId;
    }

    public void setResultUnloadPlaceId(BigDecimal resultUnloadPlaceId) {
        this.resultUnloadPlaceId = resultUnloadPlaceId;
    }

    public BigDecimal getSegmentSqe() {
        return segmentSqe;
    }

    public void setSegmentSqe(BigDecimal segmentSqe) {
        this.segmentSqe = segmentSqe;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", resultId=").append(resultId);
        sb.append(", resultNumber=").append(resultNumber);
        sb.append(", resultTotalId=").append(resultTotalId);
        sb.append(", resultStartTime=").append(resultStartTime);
        sb.append(", resultEndTime=").append(resultEndTime);
        sb.append(", resultDuration=").append(resultDuration);
        sb.append(", unloadStatus=").append(unloadStatus);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleteName=").append(deleteName);
        sb.append(", deleteTime=").append(deleteTime);
        sb.append(", resultUnloadPlaceId=").append(resultUnloadPlaceId);
        sb.append(", segmentSqe=").append(segmentSqe);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}