package com.steerinfo.dil.service;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/26 14:42
 */

public interface IUtilsService {

    //添加运单Id
    BigDecimal selectOrderMaxId();

    //查询运输订单子表主键ID
    BigDecimal selectOrderMaterialMaxId();

    //通过运力ID 修改运力状态
    int updateCapacityStatus(Map<String, Object> map, Integer status);

    //正常关闭订单
    int closeOrderNormally(Map<String, Object> map);

    //通过仓库名称查询仓库Id
    Integer queryWarehouseIdByName(String warehouseName);

    //用于更新路段顺序号
    int updateOrderLineSequence(Map<String, Object> map);

    //通过月台名称查找月台Id platformName
    Integer queryPlatformIdByName(String platformName);

    //查询当前路段顺序号
    Integer getLineSequenceByOrderId(BigDecimal orderId);

    //查询订单跟订单物资中间表 查询是否有多个物资Id
    List<Integer> getAllMaterialId(Map<String, Object> map);

    //通过总实绩Id查询订单Id
    Integer getOrderIdByTotalId(Integer resultTotalId);

    //推送消息给websocket
    void pushMesToWebsocket(String capacityNumber, String pushMes);
}
