package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.StatisticalReportMapper;
import com.steerinfo.dil.service.IStatisticalReportService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/12/14 15:26
 */
@Service
public class StatisticalReportImpl implements IStatisticalReportService {

    @Autowired
    StatisticalReportMapper statisticalReportMapper;

    //查询辅料燃料统计报表
    public List<Map<String, Object>> getRLFLReport(Map<String, Object> map){
        List<Map<String, Object>> mapList = statisticalReportMapper.getAllPurchaseFLRLReport(map);
        for (Map<String, Object> mesMap : mapList) {
            Object resultEntryGateTime = mesMap.get("resultEntryGateTime");
            Object resultOutGateTime = mesMap.get("resultOutGateTime");
            if(resultEntryGateTime != null && resultOutGateTime != null){
                Date enterDate = (Date) resultEntryGateTime;
                Date outDate = (Date) resultOutGateTime;
                //计算相差时间
                long dTime = outDate.getTime() - enterDate.getTime();
                mesMap.put("inPlantDwellTime", dTime / 60000 + "分钟");
            }
            if(resultEntryGateTime != null && resultOutGateTime == null){
                //如果没有出厂时间则以当前时间减去进厂时间
                Date enterDate = (Date) resultEntryGateTime;
                long dTime = new Date().getTime() - enterDate.getTime();
                mesMap.put("inPlantDwellTime", dTime / 60000 + "分钟");
            }
        }
        return mapList;
    }

    @Override
    public List<Map<String, Object>> getAllPurchaseFLRLReport(Map<String, Object> map) {
        return statisticalReportMapper.getAllPurchaseFLRLReport(map);
    }


}
