package com.steerinfo.dil.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.steerinfo.dil.mapper.TmstruckMeasureCommissionMapper;
import com.steerinfo.dil.model.TmstruckMeasureCommission;
import com.steerinfo.dil.service.ITmstruckMeasureCommissionService;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.dil.util.HTTPRequestUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.*;

/**
 * TmstruckMeasureCommission服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-09 10:28
 * 类描述
 * 修订历史：
 * 日期：2021-09-09
 * 作者：generator
 * 参考：
 * 描述：TmstruckMeasureCommission服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstruckMeasureCommissionService")
public class TmstruckMeasureCommissionServiceImpl implements ITmstruckMeasureCommissionService{

    @Autowired
    private TmstruckMeasureCommissionMapper tmstruckMeasureCommissionMapper;

   /**
     * 查询计量委托 0 ：计皮     1：计毛
     * @param map orderTypee 订单类型   type 是计皮还是计毛
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllMeasureCommission(Map<String, Object> map) {
        Integer orderType = (Integer) map.get("orderTypee");
        switch (orderType){
            case 1:

                break;
            case 2:

                break;
            case 3:

                break;
            case 4:

                break;
            case 5:
                break;
            case 6:
                break;
            case 7:
                break;
            case 8:
                return tmstruckMeasureCommissionMapper.getMeasureCommission(map);
            case 9:
                break;
            case 10:
                break;
            case 11:
        }
        return null;
    }

    /**
     * 添加计量委托 并发送采购订单计量委托
     * @param map {orderTypee: 订单类型
     *            resultTotalId：总实绩ID  orderId: 订单ID
     *            总实绩ID }
     * @return
     */
    public int addMaoMeasureCommission(Map<String, Object> map){
        int i = addMeasureCommission(map); // 添加计毛委托
        //发送数据给计量系统 必要数据 orderTypee：订单类型  resultTotalId： 总实绩Id   orderId
        //获取当前订单是属于哪个厂区订单
        Integer receiveId = 0 ;
        if(DataChange.dataToBigDecimal(map.get("orderTypee")).intValue() == 10){
             receiveId = tmstruckMeasureCommissionMapper.getReceiveIdByRequirementOrderId(map.get("orderId"));
        }else{
             receiveId = tmstruckMeasureCommissionMapper.getReceiveIdByOrderId(DataChange.dataToBigDecimal(map.get("orderId")));
        }
        if(receiveId == 1){
            //发送委托给达州钢铁
            i += sendMeasureCommissionMes(map);
        }
        if(receiveId == 2) {
            //发送委托给达兴能源
            i += sendDXMeasureCommissionMes(map);
        }
        return i;
    }

    /**
     * 发送销售订单计量委托
     * @param map
     * @return
     */
    public int addXSMeasureCommission(Map<String, Object> map){
        int i = addMeasureCommission(map); // 添加计毛委托
        //发送数据给计量系统 必要数据 orderTypee：订单类型  resultTotalId： 总实绩Id   orderId
        //获取当前订单是属于哪个厂区订单
        Integer shipperId = tmstruckMeasureCommissionMapper.getShipperIdByOrderId(DataChange.dataToBigDecimal(map.get("orderId")));
        if(shipperId == 1){
            //发送委托给达州钢铁
            i += sendMeasureCommissionMes(map);
        }
        if(shipperId == 2) {
            //发送委托给达兴能源
            i += sendDXMeasureCommissionMes(map);
        }
        return i;
    }

    /**
     * 添加零星物资计量委托
     * @param map
     * @return
     */
    public int addLXMeasureCommission(Map<String, Object> map){
        int i = addMeasureCommission(map); // 添加计毛委托
        i += sendDXMeasureCommissionMes(map);
        return i;
    }


    /**
     * 新增计毛、计皮委托
     * @return
     */
    @Override
    public int addMeasureCommission(Map<String, Object> map) {
        TmstruckMeasureCommission tmstruckMeasureCommission = new TmstruckMeasureCommission();
        //生成主键Id
        tmstruckMeasureCommission.setCommssionId(tmstruckMeasureCommissionMapper.selectMaxId());
        //添加物资ID
        tmstruckMeasureCommission.setMaterialId(DataChange.dataToBigDecimal(map.get("materialId")));
        //添加汽车衡Id
        if(map.get("grossPlaceId") != null){
            tmstruckMeasureCommission.setCalculateId(DataChange.dataToBigDecimal(map.get("grossPlaceId")));
        }
        if(map.get("tarePlaceId") != null){
            tmstruckMeasureCommission.setCalculateId(DataChange.dataToBigDecimal(map.get("tarePlaceId")));
        }
        //添加实绩总表Id
        tmstruckMeasureCommission.setResultTotalId(DataChange.dataToBigDecimal(map.get("resultTotalId")));
        tmstruckMeasureCommission.setInsertTime(new Date());
        tmstruckMeasureCommission.setInsertUsername("admin");
        return tmstruckMeasureCommissionMapper.insertSelective(tmstruckMeasureCommission);
    }


    /**
     * 查询计量委托并向计量系统发送数据  调用他们接口
     * 1：销售订单；2：焦炭发运计划；3：水渣发运计划；4：内转到异地库；5：采购辅料订单；6：采购老区燃料订单；
     * 7：采购新区燃料订单；8：采购进口矿(万州-厂内)；9：采购内转(达州-厂内)；10：采购内转(老区-厂内)； 11：厂内内转
     * @param map orderTypee 订单类型  type 计皮0还是计毛1类型  orderId  订单ID
     */
    public int sendMeasureCommissionMes(Map<String, Object> map){
        Map<String, Object> measureCommission = null;
        //查询计量委托
        BigDecimal orderType = DataChange.dataToBigDecimal(map.get("orderTypee"));
        switch (orderType.intValue()){
            case 1:

                break;
            case 2:
                break;
            case 3:
                break;
            case 10:
            case 11:
            case 4:

                break;
            case 5:
            case 6:
            case 7:
            case 8:
            case 9:
                measureCommission =  tmstruckMeasureCommissionMapper.purchaseMeasure(map);
                measureCommission.put("isRelationEAS", true);
                measureCommission.put("flowTo", "进厂");
                measureCommission.put("isDel", false);
                measureCommission.put("isInsert", true);
                measureCommission.put("IsAssembly", false);
                measureCommission.put("deliveryMethod", "磅重交货");
                measureCommission.put("packagesNum", 0);
        }
        /*访问接口发送数据*/
//        sendMesToMeasure(measureCommission);
        return 1;
    }


    /**
     * 发送计量委托给达兴能源 计量
     * @param map
     * @return
     */
    public int sendDXMeasureCommissionMes(Map<String, Object> map){
        Map<String, Object> measureCommission = null;
        //查询计量委托
        BigDecimal orderType = DataChange.dataToBigDecimal(map.get("orderTypee"));
        switch (orderType.intValue()){
            case 1:
            case 2:
            case 3:
                measureCommission = tmstruckMeasureCommissionMapper.saleDXMeasure(map); //订单ID  物资ID  计量实绩ID
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("billType", "1");
                measureCommission.put("crname", "admin");
                measureCommission.put("ended", "0");
                break;
            case 4:
                break;
            case 5:
            case 6:
            case 7:
            case 8:
                measureCommission =  tmstruckMeasureCommissionMapper.purchaseDXMeasure(map);
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("billType", "0");
                measureCommission.put("crname", "admin");
                measureCommission.put("ended", "0");
            case 9:
                break;
            case 10:
                //新区采购内转
                measureCommission = tmstruckMeasureCommissionMapper.purchaseXqCgNzDXMeasure(map);
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("billType", "0");
                measureCommission.put("crname", "admin");
                measureCommission.put("ended", "0");
                break;
            case 11:
                break;
            case 12:
                measureCommission = tmstruckMeasureCommissionMapper.sporadicDXMeasure(map);
                measureCommission.put("regionName", " "); //无法确定汽车衡
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("billType", "2");
                measureCommission.put("planQuantity", "0");
                measureCommission.put("crname", "admin");
                measureCommission.put("orderSource", "0");
                measureCommission.put("ended", "0");
                break;
            case 13:
            case 14:

        }
        /*访问接口发送数据*/
        return sendMesToDXMeasure(measureCommission);
    }

    /**
     *
     * 访问老厂区计量接口方法
     * @param map
     * @return
     */
    public int sendMesToMeasure(Map<String, Object> map){
        List<Map<String, Object>> sendMap = new ArrayList<>();
        sendMap.add(map);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("data", sendMap);

        String url = "http://172.16.33.122:44325/api/logistics/TareApplyFor";
        String jsonData = null;
        try {
            jsonData = HTTPRequestUtils.send(url, jsonObject, "utf-8");
        } catch (IOException e) {
            e.printStackTrace();
        }
        if(!"null".equals(jsonData)){
            System.out.println(jsonData);
            HashMap hashMap = JSON.parseObject(jsonData, HashMap.class);
            boolean success = (boolean) hashMap.get("success");
            System.out.println(hashMap.get("msg"));
            if(success){
                return 1;
            }
        }
        return 0;
    }


    /**
     * 访问新厂区达兴能源计量接口方法
     * @param map
     * @return
     */
    public int sendMesToDXMeasure(Map<String, Object> map){
        JSONObject jsonObject = new JSONObject();
        jsonObject.putAll(map);
        String url = "http://172.16.59.251:8121/daXingWeight/OrderBusiness/addOrder.do";
        String jsonData = null;
        try {
            jsonData = HTTPRequestUtils.send(url, jsonObject, "utf-8");
        } catch (IOException e) {
            e.printStackTrace();
        }
        if(!"null".equals(jsonData)){
            System.out.println(jsonData);
            HashMap hashMap = JSON.parseObject(jsonData, HashMap.class);
            String code = (String) map.get("code");
            System.out.println(hashMap.get("msg"));
            if("0".equals(code)){
                return 1;
            }
        }
        return 0;
    }
}
