package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.TmstruckQualityResultMapper;
import com.steerinfo.dil.model.TmstruckQualityResult;
import com.steerinfo.dil.
service.ITmstruckQualityResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * TmstruckQualityResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-11 04:14
 * 类描述
 * 修订历史：
 * 日期：2021-09-11
 * 作者：generator
 * 参考：
 * 描述：TmstruckQualityResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstruckQualityResultService")
public class TmstruckQualityResultServiceImpl implements ITmstruckQualityResultService {

    @Autowired
    private TmstruckQualityResultMapper tmstruckQualityResultMapper;

    /**
     * 查询所有的质检作业
     * 1：销售订单；2：焦炭发运计划；3：水渣发运计划；4：内转到异地库；5：采购辅料订单；6：采购老区燃料订单；
     * 7：采购新区燃料订单；8：采购进口矿(万州-厂内)；9：采购内转(达州-厂内)；10：采购内转(老区-厂内)； 11：厂内内转
     * @param map
     * @return
     */
    @Override
    public List<Map<String, Object>> getQualityResult(Map<String, Object> map) {
        Integer orderType = (Integer)map.get("orderTypee");
        switch (orderType){
            case 1:
                break;
            case 2:
                break;
            case 3:
                break;
            case 4:
                break;
            case 5:
            case 6:
            case 7:
            case 8:
                return tmstruckQualityResultMapper.getQualityResult(map); //apiId:150
            case 9:
            case 10:
                return tmstruckQualityResultMapper.getInwardQualityResult(map); //apiId:150
            case 11:
                break;

        }
        return null;
    }

    /**
     * 通过Id查询质检作业 用于修改显示
     * @param resultId
     * @return
     */
    @Override
    public List<Map<String, Object>> getQualityResultById(Integer resultId) {
        return tmstruckQualityResultMapper.getQualityResultById(resultId);
    }

    /**
     * 修改质检作业
     * @param tmstruckQualityResult
     * @return
     */
    @Override
    public int updateQualityResult(TmstruckQualityResult tmstruckQualityResult) {
        tmstruckQualityResult.setUpdateUsername("admin");
        tmstruckQualityResult.setUpdateTime(new Date());
        tmstruckQualityResultMapper.updateByPrimaryKeySelective(tmstruckQualityResult);
        return 0;
    }

}
